//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMainForm *MainForm;

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
//   OnCreate
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	Application->OnShortCut = &ApplicationShortCut;
	Application->OnActivate = &ApplicationActivation;
	Application->OnDeactivate = &ApplicationDeactivation;

	DecimalSeparator = '.';

	DevicesListBox->ItemIndex = CurVirtualSlot = 0x0;
	CurVirtualSlotEdit->Text = IntToStr(CurVirtualSlot);

	//   DeviceListBox,  - 
	for(WORD i = 0; i < MAX_VIRTUAL_SLOTS_NUMBER; i++) DevicesListBox->Items->Strings[i] = "  " + IntToStr(i) + ": ";
/*	DevicesListBox->Font->Size = 10.0;
	DevicesListBox->Height = MAX_VIRTUAL_SLOTS_NUMBER*DevicesListBox->ItemHeight + 7;
	ModuleLoadingButton->Top = DevicesListBox->Top + DevicesListBox->Height + 7;
	ClientHeight = ModuleLoadingButton->Top + ModuleLoadingButton->Height + 5;
  */
	InitFlashParams();
}

//---------------------------------------------------------------------------
//    ESCAPE  
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationShortCut(TWMKey &Msg, bool &Handled)
{
	if(Msg.CharCode == VK_ESCAPE)
   	if(Application->MessageBox("   ?", " !", MB_YESNO + MB_ICONQUESTION) == IDYES)
      	Application->Terminate();
}

//---------------------------------------------------------------------------
//      
//---------------------------------------------------------------------------
void TMainForm::InitFlashParams(void)
{
	ModuleLoadingLed->Brush->Color = clBtnFace;
	BoardName->Text = "????????";
	DspType->Text = "??????????";
	SerialNumber->Text = "????????";
	ClockFrequency->Text = "??????";
	Revision->Text = "?";
	StaticText7->Enabled = true;
	IsDacPresented->Enabled = true;
	IsDacPresented->Text = "????";
	AvrVersion->Text = "????";
	DspVersion->Text = "?????";
	UsbSpeedEdit->Text = "???";   
}

//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimerTimer(TObject *Sender)
{
	WORD i;
	DWORD DllVersion;
	AnsiString string;

	//    DLL 
   DllVersion = RtGetDllVersion();
	if(DllVersion != CURRENT_VERSION_RTUSBAPI)
	{
		Timer->Enabled = false;
   	AnsiString Mes = "     Rtusbapi.dll.\n";
      Mes += "                  : " + AnsiString(DllVersion >> 0x10) + "." + (DllVersion & 0xFFFFL);
		Mes += ". : " + AnsiString(CURRENT_VERSION_RTUSBAPI >> 0x10) + "." + (CURRENT_VERSION_RTUSBAPI & 0xFFFFL);
		Application->MessageBox(Mes.c_str(), "!!!", MB_OK + MB_ICONINFORMATION);
      Close(); return;
	}

	//      USB-
	IRTUSBDETECT *pModule = static_cast<IRTUSBDETECT *>(RtCreateInstance("usbdetect"));
	if(!pModule) { Timer->Enabled = false; Application->MessageBox("    IRTUSBDETECT  USB-  R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); Close(); return; }

	//   MAX_VIRTUAL_SLOTS_NUMBER    
	//     R-Technology
	for(i = 0x0; i < MAX_VIRTUAL_SLOTS_NUMBER; i++)
	{
		if(pModule->OpenDevice(i))
		{
			char ModuleName[10];

			//   
			if(!pModule->GetModuleName(ModuleName)) VirtualSlotTable[i] = false;
			//
			else if(!StrComp(ModuleName, "USB2185"))
			{
				VirtualSlotTable[i] = true;
				if(!OldVirtualSlotTable[i])
				{
					string = "  " + IntToStr(i) + ":  USB2185";
					DevicesListBox->Items->Strings[i] = string;
				}
			}
			//         
			else if(!StrComp(ModuleName, "USB3000"))
			{
				VirtualSlotTable[i] = true;
				if(!OldVirtualSlotTable[i])
				{
					string = "  " + IntToStr(i) + ":  USB3000";
				   	DevicesListBox->Items->Strings[i] = string;
				}
			}
			else
			{
				VirtualSlotTable[i] = false;
				if(OldVirtualSlotTable[i])
				{
					string = "  " + IntToStr(i) + ":  ";
					DevicesListBox->Items->Strings[i] = string;
				}
			}
		}
		else
		{
			VirtualSlotTable[i] = false;
			if(OldVirtualSlotTable[i])
			{
				string = "  " + IntToStr(i) + ": ";
				DevicesListBox->Items->Strings[i] = string;
			}
		}
	}

	//  
	for(i = 0x0; i < MAX_VIRTUAL_SLOTS_NUMBER; i++) OldVirtualSlotTable[i] = VirtualSlotTable[i];
	//    ,      
	if(!VirtualSlotTable[CurVirtualSlot]) InitFlashParams();
	//  
	ModuleLoadingButton->Enabled = true;
	//   
	pModule->ReleaseInstance();
}

//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxDblClick(TObject *Sender)
{
	//  
	char ModuleName[10];

	Timer->Enabled = false;
	ModuleLoadingButton->Enabled = false;
	DevicesListBox->Enabled = false;
	InitFlashParams();

	//    
	CurVirtualSlot = (WORD)(DevicesListBox->ItemIndex);
	//  
	CurVirtualSlotEdit->Text = IntToStr(CurVirtualSlot);
	Application->ProcessMessages();

	if(!VirtualSlotTable[CurVirtualSlot]) { Application->MessageBox("   !", "!!!", MB_OK + MB_ICONWARNING); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; Timer->Enabled = true; return; }

	//      USB-
	IRTUSBDETECT *pModule = static_cast<IRTUSBDETECT *>(RtCreateInstance("usbdetect"));
	if(pModule == NULL) { Application->MessageBox("    IRTUSBDETECT    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; return; }

	//   -     
	if(!pModule->OpenDevice(CurVirtualSlot)) { Application->MessageBox("     ", "!!!", MB_OK + MB_ICONINFORMATION); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; return; }
	//       
	else if(!pModule->GetModuleName(ModuleName)) { Application->MessageBox("    !", "!!!", MB_OK + MB_ICONINFORMATION); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; return; }
	//  .     
	else if(!pModule->ReleaseDevice()) { Application->MessageBox("    IRTUSBDETECT    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; return; }

	//     
	if(!StrComp(ModuleName, "USB2185")) LoadingUsb2185();
	else if(!StrComp(ModuleName, "USB3000")) LoadingUsb3000();
	else { Application->MessageBox("  '!", "!!!", MB_OK + MB_ICONINFORMATION); DevicesListBox->Enabled = true; ModuleLoadingButton->Enabled = true; return; }

	DevicesListBox->Enabled = true;
	ModuleLoadingButton->Enabled = true;
	Timer->Enabled = true;
}

//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxKeyPress(TObject *Sender, char &Key)
{
	//   RETURN,        
	if(Key == VK_RETURN) { DevicesListBoxDblClick((TObject *)DevicesListBox); DevicesListBox->SetFocus(); }
}

//---------------------------------------------------------------------------
//    ' '
//---------------------------------------------------------------------------
void __fastcall TMainForm::ModuleLoadingButtonClick(TObject *Sender)
{
	//       
	DevicesListBoxDblClick((TObject *)DevicesListBox);
	ModuleLoadingButton->SetFocus();
}

//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationActivation(TObject *Sender)
{
	DevicesListBox->ItemIndex = CurVirtualSlot;
}

//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationDeactivation(TObject *Sender)
{
	DevicesListBox->ItemIndex = -1;
}

//---------------------------------------------------------------------------
//   USB2185
//---------------------------------------------------------------------------
void TMainForm::LoadingUsb2185(void)
{
	//    
	IRTUSB2185 *pUsb2185;
	//     USB
	BYTE UsbSpeed;
	//  
	char ModuleName[10];
	//   
	char ModuleSerialNumber[19];
	//   AVR
	char AvrVersion[5];
	// ,      DSP
	RTUSB2185::DSP_INFO di;

	//      USB2185
	pUsb2185 = static_cast<IRTUSB2185 *>(RtCreateInstance("usb2185"));
	if(pUsb2185 == NULL) { ModuleLoadingLed->Brush->Color = clRed; Application->MessageBox("    IRTUSB2185    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); return; }

	//   -     
	if(!pUsb2185->OpenDevice(CurVirtualSlot)) { ModuleLoadingError(pUsb2185, "     !"); return; }
	//   
	else if(!pUsb2185->GetModuleName(ModuleName)) { ModuleLoadingError(pUsb2185, "    !"); return; }
	//      USB
	else if(!pUsb2185->GetUsbSpeed(&UsbSpeed)) { ModuleLoadingError(pUsb2185, "      USB!"); return; }
	//    
	else if(!pUsb2185->GetModuleSerialNumber(ModuleSerialNumber)) { ModuleLoadingError(pUsb2185, "     !"); return; }
	//    AVR
	else if(!pUsb2185->GetAvrVersion(AvrVersion)) { ModuleLoadingError(pUsb2185, "     AVR!"); return; }
	//     DSP
	else if(!pUsb2185->LOAD_DSP()) { ModuleLoadingError(pUsb2185, "    DSP   USB-2185!"); return; }
	//     
 	else if(!pUsb2185->MODULE_TEST()) { ModuleLoadingError(pUsb2185, " USB-2185  !"); return; }
	//       DSP
	else if(!pUsb2185->GET_DSP_INFO(&di)) { ModuleLoadingError(pUsb2185, "     DSP!"); return; }
	//  .     
	else if(!pUsb2185->ReleaseDevice()) { Application->MessageBox("    IRTUSB2185!", "!!!", MB_OK + MB_ICONINFORMATION); return; }

	//    
	BoardName->Text = ModuleName;
	SerialNumber->Text = ModuleSerialNumber;
	DspType->Text = (AnsiString)"ADSP-2185M";
	ClockFrequency->Text = FormatFloat("0.", RTUSB2185::DSP_CLOCK_OUT);
	Revision->Text = 'A';
	StaticText7->Enabled = false;
	IsDacPresented->Enabled = false;
	IsDacPresented->Text = "---";
	TMainForm::AvrVersion->Text = AvrVersion;
	DspVersion->Text = (AnsiString)di.DspMajor + "." + (AnsiString)di.DspMinor;
	UsbSpeedEdit->Text = UsbSpeed ? "480" : " 12";

	//  !   
	ModuleLoadingLed->Brush->Color = clLime;
}

//---------------------------------------------------------------------------
//   USB3000
//---------------------------------------------------------------------------
void TMainForm::LoadingUsb3000(void)
{
	//    
	IRTUSB3000 *pUsb3000;
	//     USB
	BYTE UsbSpeed;
	//  
	char ModuleName[10];
	//   
	char ModuleSerialNumber[19];
	//   AVR
	char AvrVersion[5];
	// ,      DSP
	RTUSB3000::DSP_INFO di;
	// ,     
	RTUSB3000::FLASH fi;

	//    size  RTUSB3000::FLASH
	fi.size = sizeof(RTUSB3000::FLASH);

	//      USB3000
	pUsb3000 = static_cast<IRTUSB3000 *>(RtCreateInstance("usb3000"));
	if(pUsb3000 == NULL) { ModuleLoadingLed->Brush->Color = clRed; Application->MessageBox("    IRTUSB3000    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); return; }

	//   -     
	if(!pUsb3000->OpenDevice(CurVirtualSlot)) { ModuleLoadingError(pUsb3000, "     !"); return; }
	//   
	else if(!pUsb3000->GetModuleName(ModuleName)) { ModuleLoadingError(pUsb3000, "    !"); return; }
	//      USB
	else if(!pUsb3000->GetUsbSpeed(&UsbSpeed)) { ModuleLoadingError(pUsb3000, "      USB!"); return; }
	//    
	else if(!pUsb3000->GetModuleSerialNumber(ModuleSerialNumber)) { ModuleLoadingError(pUsb3000, "     !"); return; }
	//    AVR
	else if(!pUsb3000->GetAvrVersion(AvrVersion)) { ModuleLoadingError(pUsb3000, "     AVR!"); return; }
	//      
	else if(!pUsb3000->GET_FLASH(&fi)) { ModuleLoadingError(pUsb3000, "      !"); return; }
	//     DSP
	else if(!pUsb3000->LOAD_DSP()) { ModuleLoadingError(pUsb3000, "    DSP   USB-3000!"); return; }
	//     
 	else if(!pUsb3000->MODULE_TEST()) { ModuleLoadingError(pUsb3000, " USB-3000  !"); return; }
	//       DSP
	else if(!pUsb3000->GET_DSP_INFO(&di)) { ModuleLoadingError(pUsb3000, "     DSP!"); return; }
	//  .     
	else if(!pUsb3000->ReleaseDevice()) { Application->MessageBox("    IRTUSB3000!", "!!!", MB_OK + MB_ICONINFORMATION); return; }

	//    
	BoardName->Text = (char *)fi.Name;
	SerialNumber->Text = (char *)fi.SerialNumber;
	DspType->Text = (char *)fi.DspType;
	ClockFrequency->Text = FormatFloat("0.", fi.DspClockout);
	Revision->Text = (char)fi.Revision;
	StaticText7->Enabled = true;
	IsDacPresented->Enabled = true;
	IsDacPresented->Text = fi.IsDacPresented ? "" : "";
	TMainForm::AvrVersion->Text = AvrVersion;
	DspVersion->Text = (AnsiString)di.DspMajor + "." + (AnsiString)di.DspMinor;
	UsbSpeedEdit->Text = UsbSpeed ? "480" : " 12";

	//  !   
	ModuleLoadingLed->Brush->Color = clLime;
}

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void TMainForm::ModuleLoadingError(LPVOID pModule, char *ErrorString)
{
	ModuleLoadingLed->Brush->Color = clRed;
	Application->MessageBox(ErrorString, "!!!", MB_OK + MB_ICONINFORMATION);

	if(pModule == NULL) { Application->MessageBox("  !", "!!!", MB_OK + MB_ICONINFORMATION); return; }
	IRTUSBDETECT *ptr = static_cast<IRTUSBDETECT *>(pModule);
	if(ptr == NULL) { Application->MessageBox("    IRTUSB2185    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION); return; }
	else if(!ptr->ReleaseDevice()) Application->MessageBox("    IRTUSBDETECT    R-Technology!", "!!!", MB_OK + MB_ICONINFORMATION);

	return;
}
