//---------------------------------------------------------------------------
#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "Rtusbapi.h"

#define MAX_VIRTUAL_SLOTS_NUMBER 			9

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TListBox *DevicesListBox;
	TStaticText *StaticText1;
	TStaticText *StaticText13;
	TShape *ModuleLoadingLed;
	TGroupBox *BoardPars;
	TStaticText *StaticText7;
	TStaticText *StaticText3;
	TStaticText *StaticText4;
	TStaticText *StaticText2;
	TStaticText *StaticText6;
	TEdit *BoardName;
	TEdit *SerialNumber;
	TStaticText *StaticText5;
	TEdit *DspType;
	TEdit *Revision;
	TEdit *ClockFrequency;
	TEdit *IsDacPresented;
	TButton *ModuleLoadingButton;
	TStaticText *StaticText8;
	TTimer *Timer;
	TStaticText *StaticText9;
	TEdit *CurVirtualSlotEdit;
	TStaticText *StaticText10;
	TEdit *AvrVersion;
	TStaticText *StaticText11;
	TEdit *DspVersion;
	TEdit *UsbSpeedEdit;
	TStaticText *StaticText12;
	TStaticText *StaticText14;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall DevicesListBoxDblClick(TObject *Sender);
	void __fastcall DevicesListBoxKeyPress(TObject *Sender, char &Key);
	void __fastcall ModuleLoadingButtonClick(TObject *Sender);

private:	// User declarations
	void __fastcall ApplicationShortCut(TWMKey &Msg, bool &Handled);
	void __fastcall ApplicationActivation(TObject *Sender);
	void __fastcall ApplicationDeactivation(TObject *Sender);
	void InitFlashParams(void);
	void LoadingUsb2185(void);
	void LoadingUsb3000(void);
	void ModuleLoadingError(LPVOID pModule, char *ErrorString);

   WORD CurVirtualSlot;
   bool VirtualSlotTable[MAX_VIRTUAL_SLOTS_NUMBER], OldVirtualSlotTable[MAX_VIRTUAL_SLOTS_NUMBER];


public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
